# Пример работы поворотников в автоматическом режиме:

#  Параметры функции    settingsTurnAuto():
#  - ПЕРВЫЙ ПАРАМЕТР    (условие включения поворотника):
#    BUM_AUTO_ON_1    - поворотник включается при наличии линии под любым из двух самых крайних датчиков со стороны поворотника
#    BUM_AUTO_ON_2    - поворотник включается при наличии линии под любым из трех самых крайних датчиков со стороны поворотника.
#    BUM_AUTO_ON_3    - поворотник включается при наличии линии под любым из четырёх датчиков со стороны поворотника.
#  - ВТОРОЙ ПАРАМЕТР    (условие отключения поворотника):
#    BUM_AUTO_OFF_CEN - поворотник отключается при налиячии линии под центральным датчиком бампера.
#    BUM_AUTO_OFF_ANY - поворотник отключается при налиячии линии под любым датчиком, кроме указанных в условии включения поворотника.
#  - ТРЕТИЙ ПАРАМЕТР    (дополнительное время):
#    Если в качестве третьего, необязательного, параметра указать true, то поворотники будут отключаться не сразу, а спустя два мигания.

#   Подключаем библиотеку для работы с бампером I2C-flash.
from pyiArduinoI2Cbumper import *

#   Объявляем объект bum для работы с функциями и методами библиотеки
#   pyiArduinoI2Cbumper, указывая адрес модуля на шине I2C.
#   Если объявить объект без указания адреса bum = pyiArduinoI2Cbumper(),
#   то адрес будет найден автоматически.
bum = pyiArduinoI2Cbumper(0x09)

#   Задаём скорость мигания поворотников в 400мс. Возможные значения: BUM_TURN_100, BUM_TURN_200, BUM_TURN_400 и BUM_TURN_800.
bum.setTurnPeriod(BUM_TURN_400)

#   Задаём условия автоматического включения и отключения поворотников:
#   BUM_AUTO_ON_1 - включать при наличии линии под любым из двух самых крайних датчиков,
#   BUM_AUTO_OFF_CEN - отключить если линия на центральном датчике.
bum.settingsTurnAuto(BUM_AUTO_ON_1, BUM_AUTO_OFF_CEN)

#   Указываем поворотникам работать в автоматической режиме.
bum.setTurnSignal(BUM_TURN_AUTO)
